<?xml version="1.0" encoding="ISO-8859-1" standalone="yes"?>
<!--
This is just the common part of all transformer: this styleshet is to be imported in all convertors.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xrn="http://xmlreleasenotes.free.fr" version="1.0">
	<xsl:output method="xml" indent="yes" encoding="ISO-8859-1"/>
	<!--
	The 'XRN_TARGET_VERSION' variable should be defined and equal to the version we migrate up to.
	-->
	<xsl:template match="xrn:ReleaseNotes">
		<xsl:copy>
			<xsl:choose>
				<xsl:when test="@version">
					<xsl:for-each select="@*">
						<xsl:choose>
							<xsl:when test="name() = 'version'">
								<xsl:attribute name="version"><xsl:value-of select="$XRN_TARGET_VERSION"/></xsl:attribute>
								<xsl:if test=". >= '$XRN_TARGET_VERSION'">
									<xsl:message>Warning: migrating a XRN release notes file with a version greater than what the transformer can handle.</xsl:message>
								</xsl:if>
							</xsl:when>
							<xsl:otherwise>
								<xsl:copy-of select="."/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="version"><xsl:value-of select="$XRN_TARGET_VERSION"/></xsl:attribute>
					<xsl:for-each select="@*">
						<xsl:apply-templates/>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="*">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="comment() | processing-instruction()">
		<xsl:copy/>
	</xsl:template>
	<xsl:template match="node()" mode="copy">
		<xsl:element name="{name()}">
			<xsl:apply-templates select="@* | * | text()" mode="copy"/>
		</xsl:element>
	</xsl:template>
	<xsl:template match="@*" mode="copy">
		<xsl:attribute name="{name()}"><xsl:value-of select="."/></xsl:attribute>
	</xsl:template>
	<xsl:template match="text()" mode="copy">
		<xsl:value-of select="."/>
	</xsl:template>
</xsl:stylesheet>
